<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Models\Booking;
use App\Models\BookingItems;
use App\Models\Tickets;
use App\Models\Location;
use App\Models\Modifiers;
use App\Http\Controllers\webhookController;
use App\Http\Controllers\apiController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

// Alvarado API's
Route::group(['prefix' => '/middlewareApi/v1/ticket'], function () {
    Route::post('/ping',[apiController::class,'ping']);
    Route::post('/sync',[apiController::class,'deviceSync']);
    Route::post('/validate',[apiController::class,'ticketValidation']);
    Route::post('/force',[apiController::class,'forceValidation']);
    Route::post('/group',[apiController::class,'groupTicketValidation']);
    Route::post('/info',[apiController::class,'ticketInfo']);
    Route::post('/void',[apiController::class,'void']);
});

Route::post("/middlewareApi/v1/getBookingData",[apiController::class,'getData']);

Route::any('{any}', function () {
    return response()->json(['error' => 'URL not found'], 404);
})->where('any', '.*');

