<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Booking;
use App\Models\BookingItems;
use App\Models\Tickets;
use App\Models\Location;
use App\Models\Modifiers;
use Illuminate\Support\Facades\DB;
use Log;

class webhookController extends Controller
{
    public function authToken(){
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => config('global.mainUrl').config('global.accessToken'),
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>"{
            'client_id': '".env('CLIENT_ID')."',
            'client_secret': '".env('CLIENT_SECRET')."'
            }",
            CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);
        curl_close($curl);
        return $response;
    }

    protected function headerApi($url, $method='GET',$body=''){
        $curl = curl_init();
        $accessToken = json_decode($this->authToken())->access_token;
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $method,
            CURLOPT_POSTFIELDS =>$body,
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'Authorization: bearer '.$accessToken.''
            ),
        ));
        
        $response = curl_exec($curl);
        curl_close($curl);
        return $response;
    }

    public function getWebhooks(){
        $url = config('global.mainUrl').config('global.Webhooks');
        $webhooks = $this->headerApi($url);
        return $webhooks;
    }

    public function productDetails(){
        $productCategory = 'Tickets';
        $url = config('global.mainUrl').config('global.productDetails').'?productCategory='.$productCategory;
        $productDetails = $this->headerApi($url);
        return $productDetails;
    }

    public function createWeebhooks(){
        $url = config('global.mainUrl').config('global.Webhooks');
        $method = "POST";
        $body = '{
            "url": "http://127.0.0.1:8000/test-webhook111",
            "enabled": true,
            "authentication": {
              "apiKey": "pLos7DQmyGPCuxo4huk-XJCmS5fEN2rMm48feExUKtO1NlpPe1cDyw0Xai3qPGo3"
            },
            "webhooks": {
                "booking": {
                  "include": {
                    "externalId": true,
                    "tickets": true,
                    "membershipDetail": true,
                    "locations": true
                  },
                  "filter": {
                    "channels": [
                      1,
                      2,
                      3,
                      4
                    ],
                    "productTypes": [
                      1,
                      2,
                      3,
                      4
                    ]
                  },
                  "events": [
                    1, 2, 3
                  ]
                },
                "redemption": {
                  "include": {
                    "signedWaiver": true
                  },
                  "filter": {},
                  "events":
                    [
                      1
                    ]
                },
              "customer": {
                "events":
                  [
                    1, 2
                  ]
               }
              }
            }';
        $productDetails = $this->headerApi($url,$method,$body);
        return $productDetails;
    }

    public function store(request $request){

      try {
        // echo"<pre>";print_r($request->all());die;
        $authKey = $request->header('x-roller-apikey');
        if ($authKey == env('CLIENT_SECRET')) {
          DB::beginTransaction();
          //For Booking Table
          $booking = new Booking;
          $booking->bookingReference = $request['bookingReference'];
          $booking->externalId = $request['externalId'];
          $booking->uniqueId = $request['uniqueId'];
          $booking->source = $request['source'];
          $booking->status = $request['status'];
          $booking->name = $request['name'];
          $booking->createdDate = $request['createdDate'];
          $booking->customerId = $request['customerId'];
          $booking->companyId = $request['companyId'];
          $booking->comments = $request['comments'];
          $booking->total = $request['total'];
          $booking->remainder = $request['remainder'];
          $booking->fees = $request['fees'];
          $booking->discount = $request['discount'];
          $booking->deviceId = $request['deviceId'];
          $booking->barcodeId = $request['barcodeId'];
          $booking->save();
          
          //For Booking-Items Table
          $bookingItems = new BookingItems;
          $bookingItems->uniqueId = $request['uniqueId'];
          $bookingItems->bookingItemId = $request->items['bookingItemId'];
          $bookingItems->productId = $request->items['productId'];
          $bookingItems->quantity = $request->items['quantity'];
          $bookingItems->bookingDate = $request->items['bookingDate'];
          $bookingItems->bookingEndDate = $request->items['bookingEndDate'];
          $bookingItems->sessionStartTime = $request->items['sessionStartTime'];
          $bookingItems->sessionEndTime = $request->items['sessionEndTime'];
          $bookingItems->cost = $request->items['cost'];
          $bookingItems->discount = $request->items['discount'];
          $bookingItems->modifierId = $request->items['modifiers'][0][0]['modifierId'];
          $bookingItems->save();
          
          // For Tickets table
          $tickets = new Tickets;
          $tickets->uniqueId = $request['uniqueId'];
          $tickets->bookingItemId = $request->items['bookingItemId'];
          $tickets->ticketId = $request->items['tickets']['ticketId'];
          $tickets->customTicketId = $request->items['tickets']['customTicketId'];
          $tickets->ticketHolderName = $request->items['tickets']['ticketHolderName'];
          $tickets->membershipStatus = $request->items['tickets']['membershipStatus'];
          $tickets->photoUrl = $request->items['tickets']['photoUrl'];
          $tickets->customerId = $request->items['tickets']['customerId'];
          $tickets->save();
          
          // For Location Table
          foreach ($request->items['tickets']['locations'] as $key => $value) {
            $location = new Location;
            $location->ticketId = $request->items['tickets']['ticketId'];
            $location->location = $value;
            $location->save();
          }
  
          // For Modifiers
          $modifier = new Modifiers;
          $modifier->bookingItemId = $request->items['bookingItemId'];
          $modifier->modifierId = $request->items['modifiers'][0][0]['modifierId'];
          $modifier->amount = $request->items['modifiers'][0][0]['amount'];
          $modifier->save();
  
          DB::commit();
          return json_encode('Data is Stored Successfully');
        }
        else{
          return json_encode('UnAuthorized Request');
        }
        
      } catch (\Throwable $th) {
        DB::rollback(); Log::info($th);
        return json_encode('Data is not stored');
      }
    
    }

    public function delWebhook(){
        $webhookId = 84;
        $url = config('global.mainUrl').config('global.Webhooks').'/'.$webhookId;
        $webhooks = $this->headerApi($url);
        return $webhooks;
    }

    public function test(Request $request){
        try {
            $data = $request->all();
            // Replace the path with the location where you want to save the text file
            $filePath = storage_path('app/request_data.txt');
            file_put_contents($filePath, json_encode($data));
            return response()->json(['message' => 'Request data has been saved successfully.']);
        } catch (\Throwable $th) {
            Log::info($th);
        }
    }
}
